local Text = require "widgets/text"
local Widget = require "widgets/widget"
local Image = require "widgets/image"
local ImageButton = require "widgets/imagebutton"
local HoverText = require "widgets/hoverer"

Assets =
{
	Asset( "IMAGE", "images/position.tex" ),
	Asset( "ATLAS", "images/position.xml" ),
}

local Timer_widget = Class(Widget, function(self, owner)
	Widget._ctor(self, "Timer_widget")
	self.owner = owner
	self.scale = 1
	self.spacing = 0
	self:SetScale(self.scale,self.scale,self.scale)
	self.bgimage = self:AddChild(Image())
	self.bgimage:SetTexture("images/position.xml", "position.tex")
	self.bgimage:SetTooltip(TUNING.YIYUTIMER_INTRODUCE)

--------------------------------------------------------------------------------
--ע:ΪLongFeiдɯؼ
--------------------------------------------------------------------------------
	local function AddPoint(self,Valid)
		for k,v in pairs(Valid) do
			if Valid[k] ==true then
				self[k].point:Show()
			else
				self[k].point:Hide()
			end
		end
	end	
	function self:OnUIAddPoint(owner,data)
		if data and data.Valid then
			local Valid = data.Valid
			AddPoint(self,Valid)
		end
	end
	self.OnUIAddPointFn = function(owner,data) self:OnUIAddPoint(owner,data) end
	self.owner:ListenForEvent("UIAddPoint", self.OnUIAddPointFn)

	self.OnControl = function (self,control, down)
		self:Passive_OnControl(control, down) 
	end
end)

function Timer_widget:Passive_OnControl(control, down)
	if control == CONTROL_ACCEPT then
		if down then
			self:StartDrag()
		else
			self:EndDrag()
		end
	end
end

function Timer_widget:SetDragPosition(x, y, z)
	local pos
	if type(x) == "number" then
		pos = Vector3(x, y, z)
	else
		pos = x
	end
	self:SetPosition(pos + self.dragPosDiff)
	local Vector3_yiyu = pos + self.dragPosDiff
--	print(Vector3_yiyu.x)
--	print(Vector3_yiyu.y)
--	print(Vector3_yiyu.z)
	local com = self.owner.components.yiyutimer_save 
	if com then
		com.yiyu_timer_pos.x = Vector3_yiyu.x
		com.yiyu_timer_pos.y = Vector3_yiyu.y
		com.yiyu_timer_pos.z = Vector3_yiyu.z
		com:SetPos()
		print(com.yiyu_timer_pos.x,com.yiyu_timer_pos.y,com.yiyu_timer_pos.z)
	end
end

function Timer_widget:StartDrag()
	if not self.followhandler then
		local mousepos = TheInput:GetScreenPosition()
		self.dragPosDiff = self:GetPosition() - mousepos
		self.followhandler = TheInput:AddMoveHandler(function(x,y) self:SetDragPosition(x,y) end)
		self:SetDragPosition(mousepos)
	end
end

function Timer_widget:EndDrag()
	if self.followhandler then
		self.followhandler:Remove()
	end
	self.followhandler = nil
	self.dragPosDiff = nil
end

function Timer_widget:Scale_DoDelta(delta)
	self.scale = math.max(self.scale+delta,0.1)
	self:SetScale(self.scale,self.scale,self.scale)
--	print(self.scale)
end

function Timer_widget:spacing_DoDelta(delta)
	self.spacing = math.max(self.spacing+delta,1)
	if self.owner.HUD.yiyu_timer then
	self.owner.HUD.yiyu_timer:SetPosition(0,-self.spacing,0)
--	print(self.spacing)
	end
end

return Timer_widget